/* snoop_x.pike
 */

object port;
object client;
object server;

int client_state = 0;
int server_state = 0;

class buffer
{
  object file;
  string buffer;

  object create(object f)
    {
      file = f;
      buffer = "";
    }

  void write_callback()
    {
      int written = file->write(buffer);
      buffer = buffer[written..];
      if (!strlen(buffer))
	file->set_write_callback(0);
    }
  
  void write(string s)
    {
      buffer += s;
      if (strlen(buffer))
	file->set_write_callback(write_callback);
    }
}

class client_parser
{
  object file;
  string buffer;
  object server;
  int state;
  int sent;
  
  int endianness;

  void send(int n)
    {
      server->write(buffer[..n-1]);
      buffer = buffer[n..];
    }
  
  void read_callback(mixed id, string data)
    {
      buffer += data;
      
      while(strlen(buffer))
	switch(state)
	  {
	  case 0:
	    endianness = buffer[0];
	    write(sprintf("Endianness: '%c'\n", endianness));
	    send(1);
	    state = 1;
	    break;
	  case 1:
	    if (strlen(buffer) < 4)
	      return;
	    string mj = buffer[..1];
	    string mn = buffer[2..3];
	    send(4);
	    if (endianness = 'l')
	      {
		mj = reverse(mj);
		mn = reverse(mn);
	      }
	    int mj_n, mn_n;
	    sscanf(mj+mn, "%2c%2c", mj_n, mn_n);
	    write(sprintf("Major: %d, Minor: %d\n", mj_n, mn_n));
	    state = 2;
	    break;
	  case 2: {
	    int index = search(buffer, "\0");
	    if (index<0)
	      return;
	    write(sprintf("auth protocol: '%s'\n", buffer[..index-1]));
	    send(index+1);
	    state = 3;
	    break;
	  }
	  case 3: {
	    int index = search(buffer, "\0");
	    if (index<0)
	      return;
	    write(sprintf("auth data: '%s'\n", buffer[..index-1]));
	    send(index+1);
	    state = 4;
	    break;
	  }
	  case 4:
	    
	    
  void create(object f, object s)
    {
      file = f;
      server = s;
      buffer = "";
      state = 0;
      f->set_read_callback(read_callback);
    }
}
  
  
int cn = 0;


accept_callback()
{
  object f = port->accept();
  if (f)
    {
      ++cn;
      f->set_nonblocking(0,0,0);
      
void server_write_callback()
{
  int written = server->write(to_server);
  
int main(int argc, array(string) argv)
{
  port = Stdio.Port();
  if (!port->listen(6001))
    return 17;
  
  if (!(client=port->accept()))
    return 18;
  server = Stdio.File();
  if (!server->connect("localhost", 6000))
    return 19;

  client->
